-- Copyright 2011 Xavier Ferrair aka Mortimer @ Outland [H] (deadlygm@gmail.com)
-- no code in this file may be used in other works without expressed permission

local bg = CreateFrame("Frame")
	bg:RegisterEvent("UPDATE_BATTLEFIELD_STATUS")
	bg:SetScript("OnEvent", function(bg, event, msg)

		local winner = GetBattlefieldWinner()
		local isArena, isRegistered = IsActiveBattlefieldArena()
		local status, mapName, instanceID, bracketMin, bracketMax, teamSize, registeredMatch = GetBattlefieldStatus(1)
		local fraction = UnitFactionGroup("player")
		local iswinner = (fraction == "Horde" and winner == 0) or (fraction == "Alliance" and winner == 1) -- Horde = 0, Alliance = 1 BGS ONLY
		local islose = (fraction == "Horde" and winner == 1) or (fraction == "Alliance" and winner == 0) -- Horde = 0, Alliance = 1	BGS ONLY
		local numScores = GetNumBattlefieldScores()
	
	for n = 1, numScores do
		local name, killingBlows, honorableKills, deaths, honorGained, faction, race, class, classToken, damageDone, healingDone, bgRating, ratingChange = GetBattlefieldScore(n)
	if event == "UPDATE_BATTLEFIELD_STATUS" then
		-- Battleground normal
		if (name) and not (isArena) and (ratingChange == 0) then
			-- WIN
			if (name == UnitName("player")) and iswinner and status == "active" then
				print("|cff00FF00Won |r" ..mapName.. "|cff00FF00 with |r" ..killingBlows.. "|cff00FF00 kills of |r" ..honorableKills.. " |cff00FF00hkills");
				--SendChatMessage("Won "..mapName.." with "..killingBlows.." kills of "..honorableKills.." hkills", "GUILD", NIL);
			end
			-- LOSE
			if (name == UnitName("player")) and islose and status == "active" then
				print("|cffFE2E2ELose |r" ..mapName.. "|cffFE2E2E with |r" ..killingBlows.. "|cffFE2E2E kills of |r" ..honorableKills.. " |cffFE2E2Ehkills");
			end
		end
		-- Battleground rated
		if (name) and not (isArena) and not (ratingChange == 0) then
			-- WIN
			if (name == UnitName("player")) and iswinner and status == "active" then
				local actualRating = (bgRating + ratingChange)
				print("|cff00FF00Won |r" ..mapName.. "|cff00FF00 @ |r" ..actualRating.. "|cff00FF00 with |r" ..killingBlows.. "|cff00FF00 kills of |r" ..honorableKills.. " |cff00FF00hkills");
				--SendChatMessage("Won "..mapName.." @ "..actualRating.." with "..killingBlows.." kills of "..honorableKills.." hkills -", "GUILD", NIL);
			end
			-- LOSE
			if (name == UnitName("player")) and islose and status == "active" then
				local actualRating = (bgRating - ratingChange)
				print("|cffFE2E2ELose |r" ..mapName.. "|cffFE2E2E @ |r" ..actualRating.. "|cffFE2E2E with |r" ..killingBlows.. "|cffFE2E2E kills of |r" ..honorableKills.. " |cffFE2E2Ehkills");
			end
		end
	end
	end
end)