-- Copyright 2011 Xavier Ferrairó aka Mortimer @ Outland [H] (deadlygm@gmail.com)
-- no code in this file may be used in other works without expressed permission

local que = CreateFrame("Frame", "que", UIParent)
local quetime
local queue = 0
local remaining = 0
local popsound = 1
local inInstance, instanceType = IsInInstance()

que:SetScript("OnEvent", function(self, event, ...) self[event](self, ...) end)
que:SetScript("OnUpdate", function(self) self:Timer() end)
que:RegisterEvent("UPDATE_BATTLEFIELD_STATUS")
que:RegisterEvent("PLAYER_ENTERING_WORLD")

PVPReadyDialog.enterButton:ClearAllPoints()
PVPReadyDialog.enterButton:SetPoint("BOTTOM", PVPReadyDialog, "BOTTOM", 0, 25)
PVPReadyDialog.label:SetPoint("TOP", 0, -22)

PVPReadyDialog.leaveButton:Hide()
PVPReadyDialog.leaveButton.Show = function() end -- Prevent other mods from showing the button

function que:PLAYER_ENTERING_WORLD()
	popsound = 1
end

function que:UPDATE_BATTLEFIELD_STATUS()

	local queued
	for i=1, GetMaxBattlefieldID() do
		local status = GetBattlefieldStatus(i)		
		if status == "active" then -- de lujo
			popsound = 1
		end
		if status == "queued" then
			queued = true
			if not quetime then quetime = GetTime(); end
		elseif status == "confirm" then
			if quetime then
				self:TimeWaited()
				quetime = nil
				remaining = 0
				queue = i
			end	
		end
		break
	end
	if not queued and quetime then quetime = nil; end
end

function que:TimeWaited()

	local secs, str, mins = floor(GetTime() - quetime), "Queue popped "
	if secs < 1 then
		str = str .. "instantly!"
	else
		str = str .. "after "
		if secs >= 60 then
			mins = floor(secs/60)
			str = str .. mins .. "m "
			secs = secs%60
		end
		if secs%60 ~= 0 then
			str = str .. secs .. "s"
		end
	end
end

function que:Timer()
	if PVPReadyDialog:IsShown() then
		local secs = GetBattlefieldPortExpiration(queue)
		if remaining ~= secs and popsound == 1 then -- Pop Sound BG/Arena from arena
			PlaySoundFile("Interface\\AddOns\\Bang_Bang\\Artwork\\getready.ogg", "Master")
			popsound = 0
		end
		if secs and secs > 0 and remaining ~= secs then
			if popsound == 1 then -- Pop Sound BG/Arena
				PlaySoundFile("Interface\\AddOns\\Bang_Bang\\Artwork\\getready.ogg", "Master")
				popsound = 0
			end
			remaining = secs
			local color = secs > 20 and "f20ff20" or secs > 10 and "fffff00" or "fff0000"
			PVPReadyDialog.label:SetText("Expires in |cf"..color.. SecondsToTime(secs) .. "|r")
			-- Sound alerter BG/Arena
			if secs == 10 then
				PlaySoundFile("Interface\\AddOns\\Bang_Bang\\Artwork\\idle_alerter.ogg", "Master")
			end
			if secs == 5 then
				PlaySoundFile("Interface\\AddOns\\Bang_Bang\\Artwork\\idle_alerter.ogg", "Master")
			end
		end
	end
end