﻿-- Copyright 2011 Xavier Ferrairó aka Mortimer @ Outland [H] (deadlygm@gmail.com)
-- no code in this file may be used in other works without expressed permission

local tracker = CreateFrame("Frame")
	tracker:RegisterEvent("PLAYER_LOGIN")
	tracker:RegisterEvent("PLAYER_ENTERING_WORLD")
	tracker:RegisterEvent("PLAYER_DEAD")
	tracker:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	tracker:RegisterEvent("NAME_PLATE_CREATED")
	tracker:RegisterEvent("NAME_PLATE_UNIT_ADDED")
	tracker:RegisterEvent("NAME_PLATE_UNIT_REMOVED")

local pId = UnitGUID("player")
local realmName = GetRealmName()

-- Eventos para mostrar enemigo
SpellEvents = { 
	["SPELL_DAMAGE"] = true, 
	["SPELL_CAST_START"] = true, 
	["SPELL_PERIODIC_DAMAGE"] = true, 
	["RANGE_DAMAGE"] = true, 
	["SWING_DAMAGE"] = true, 
}

--local LibNameplate = LibStub("LibNameplate-1.0")
--local nameplate = LibNameplate:GetTargetNameplate()

local total = 0
local timecheck = 30 -- time refresh to check enemies
local timeout = 60 -- al minuto de no tener contacto con el enemigo se quitara la advertencia

------------------
HateList = CreateFrame("Frame", "HateList", UIParent)
HateList:SetSize(380,35)
HateList:SetPoint("CENTER", waPosX, waPosY)
HateList:SetBackdrop( {
	--bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
	bgFile = "Interface\Tooltips\UI-Tooltip-Background",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	--edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 10,
	edgeSize = 10,
	insets = {left = 4, right = 4, top = 4, bottom = 4}
} )
HateList:SetMovable(true)
HateList:SetUserPlaced(true)
HateList:RegisterForDrag("LeftButton")
HateList:EnableMouse(true)
HateList:SetScript("OnDragStart", function(self) HateList:StartMoving() end)
HateList:SetScript("OnDragStop", function(self) 
	
	local xpos,ypos = GetCursorPosition()
	--waPosY = BangCharDB.walerterY; waPosX = BangCharDB.walerterX
	BangCharDB.walerterX = xpos; -- save the degrees we are relative to the minimap center
	BangCharDB.walerterY = ypos; -- save the degrees we are relative to the minimap center

	HateList:StopMovingOrSizing()
end)
HateList:SetBackdropColor(.05, .05, .05, 1)
--
HateList.buttonC = CreateFrame("Button", nil, HateList, "UIPanelButtonTemplate")
HateList.buttonC:SetSize(20,20)
HateList.buttonC:SetPoint("RIGHT", -5, 0)
HateList.buttonC:SetText("X")
HateList.buttonC:SetScript("OnClick", function()
		--HateList.adv:SetFading(1)
		HateList:Hide()
end)
HateList.adv = CreateFrame("MessageFrame", "HateList", HateList)
HateList.adv:SetSize(375,18)
HateList.adv:SetPoint("CENTER", 0, 0)
HateList.adv:SetFont("Fonts\\FRIZQT__.ttf", 14, "THINOUTLINE")
HateList.adv:SetFading(false)

---------------------------------
function EnemyIcon()
	texture:Show();
	texture:SetPoint("CENTER");
	texture:SetSize(26,26);
	texture:SetTexture("Interface\\Icons\\Ability_BackStab");			
end

	tracker:SetScript("OnEvent", function(self, event, ...)

		if event == "PLAYER_LOGIN" then HateList:Hide(); player = UnitName("player"); waPosY = BangCharDB.walerterY; waPosX = BangCharDB.walerterX; end
		if event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_DEAD" then HateList:Hide() end
		
inInstance, instanceType = IsInInstance() --print(BangCharHateds[destName])
timeStamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, prefixParam1, prefixParam2, dummyparam, suffixParam1, suffixParam2 = ...
if not inInstance then
if SpellEvents[event] then
		
--TEMITA REALMS
esPlayer = strsplit("-",sourceGUID)
if esPlayer == "Player" then
	if string.find(sourceName, '%-') then
		sN = sourceName
	end
	if not string.find(sourceName, '%-') then
		sN = (sourceName.."-"..realmName)
	end
else
	sN = sourceName
end
--		
if BangHateds[sN] and bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then








	if HateList:IsVisible() then
		HateList:Hide()
		HateList.adv:AddMessage("|cffFE2E2EYour enemy |cffDDDDDD"..sN.." |cffFE2E2Eis near", .9, .9, .9, 1)
		HateList:Show()
	end
	if not HateList:IsVisible() then
		HateList.adv:AddMessage("|cffFE2E2EYour enemy |cffDDDDDD"..sN.." |cffFE2E2Eis near", .9, .9, .9, 1)
		HateList:Show()
	end
	
	hate = sN

end
end
		-- Si mato yo a mi hated
		if event == "PARTY_KILL" and player == sourceName and hate == destName and bit.band(destFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then
			--HateList.adv:SetFading(1)
			HateList:Hide()
			print("|cffFE2E2EWanted enemy |r"..destName.." |cffFE2E2Ehas been hunted.");
			RaidNotice_AddMessage(RaidBossEmoteFrame, ""..destName.." has been hunted!", ChatTypeInfo["RAID_BOSS_EMOTE"])
		end
		-- Si mi hated muere a rango mio pero no por mi
		if event == "UNIT_DIED" and not player == sourceName and hate == destName and bit.band(destFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then
			--HateList.adv:SetFading(1)
			HateList:Hide()
			DoEmote("laugh");
			print("|cffFE2E2EWanted enemy |r"..destName.." |cffFE2E2Edied around.");
			RaidNotice_AddMessage(RaidBossEmoteFrame, ""..destName.." died around!", ChatTypeInfo["RAID_BOSS_EMOTE"])
		end
end -- END world PVP
end)